#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "shell.h"

#include "ztimer.h"


static struct hello_ctx{
    size_t l;
    char * name;
    char stack[THREAD_STACKSIZE_DEFAULT];
} hello_ctx;

static void *_hello_thread(void *_ctx){
    struct hello_ctx * ctx = _ctx;
    for(;;){
        ztimer_spin(ZTIMER_SEC,2);
//         ztimer_sleep(ZTIMER_SEC,2);
        printf("Hello %s\n" , ctx->name);
    }
    return 0;
}

static int _start_hello(int argc, char **argv)
{
    (void)argc;
    (void)argv;
    size_t l = 0;
    char  *n = 0;
    int    prio_offset = 1;

    if(argc > 1){
        n = argv[1];
    }else{
        n = "unknown";
    }
    l = strlen(n);
    hello_ctx.name=calloc(1,l+1);
    strcpy(hello_ctx.name,n);

    if(argc > 2)
    {
        prio_offset = atoi(argv[2]);
    }
    thread_create(hello_ctx.stack, sizeof(hello_ctx.stack),
                  THREAD_PRIORITY_MAIN + prio_offset, THREAD_CREATE_STACKTEST,
                  _hello_thread, &hello_ctx, "hello printer");
    return 0;
}

static const shell_command_t shell_commands[] = {
    { "hello", "hello me", _start_hello },
    { NULL, NULL, NULL }
};

int main(void)
{
    char line_buf[SHELL_DEFAULT_BUFSIZE];
    shell_run(shell_commands, line_buf, SHELL_DEFAULT_BUFSIZE);
}
